VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "Comctl32.ocx"
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Server"
   ClientHeight    =   3036
   ClientLeft      =   3108
   ClientTop       =   1848
   ClientWidth     =   4488
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3036
   ScaleWidth      =   4488
   ShowInTaskbar   =   0   'False
   Begin VB.ComboBox cboComputerName 
      Height          =   288
      Left            =   108
      Style           =   2  'Dropdown List
      TabIndex        =   16
      Top             =   1404
      Width           =   4260
   End
   Begin VB.TextBox txtComputerDesc 
      Height          =   300
      Left            =   108
      TabIndex        =   14
      Top             =   1980
      Width           =   4260
   End
   Begin VB.Frame Frame1 
      Caption         =   "Usage Summary"
      Height          =   984
      Left            =   108
      TabIndex        =   4
      Top             =   144
      Width           =   4260
      Begin VB.Label lblOpenNamedPipes 
         Height          =   228
         Left            =   3528
         TabIndex        =   12
         Top             =   612
         Width           =   372
      End
      Begin VB.Label lblOpenFiles 
         Height          =   228
         Left            =   3528
         TabIndex        =   11
         Top             =   288
         Width           =   372
      End
      Begin VB.Label lblFileLocks 
         Height          =   228
         Left            =   1116
         TabIndex        =   10
         Top             =   612
         Width           =   372
      End
      Begin VB.Label lblSessions 
         Height          =   228
         Left            =   1116
         TabIndex        =   9
         Top             =   324
         Width           =   372
      End
      Begin VB.Label lblCaption 
         Caption         =   "Open Named Pipes:"
         Height          =   300
         Index           =   3
         Left            =   1908
         TabIndex        =   8
         Top             =   612
         Width           =   1488
      End
      Begin VB.Label lblCaption 
         AutoSize        =   -1  'True
         Caption         =   "Open Files:"
         Height          =   192
         Index           =   2
         Left            =   1908
         TabIndex        =   7
         Top             =   324
         Width           =   816
      End
      Begin VB.Label lblCaption 
         AutoSize        =   -1  'True
         Caption         =   "File Locks:"
         Height          =   192
         Index           =   0
         Left            =   144
         TabIndex        =   6
         Top             =   612
         Width           =   768
      End
      Begin VB.Label lblCaption 
         AutoSize        =   -1  'True
         Caption         =   "Sessions:"
         Height          =   192
         Index           =   1
         Left            =   144
         TabIndex        =   5
         Top             =   324
         Width           =   708
      End
   End
   Begin VB.CommandButton cmdClose 
      Cancel          =   -1  'True
      Caption         =   "Close"
      Height          =   588
      Left            =   3456
      TabIndex        =   3
      Top             =   2340
      Width           =   912
   End
   Begin VB.CommandButton cmdInUse 
      Caption         =   "&In Use"
      Height          =   588
      Left            =   1980
      MaskColor       =   &H00E0E0E0&
      Picture         =   "Main.frx":0000
      Style           =   1  'Graphical
      TabIndex        =   2
      Top             =   2340
      Width           =   912
   End
   Begin VB.CommandButton cmdShares 
      Caption         =   "&Shares"
      Height          =   588
      Left            =   1044
      Picture         =   "Main.frx":01C2
      Style           =   1  'Graphical
      TabIndex        =   1
      Top             =   2340
      Width           =   912
   End
   Begin VB.CommandButton cmdUsers 
      Caption         =   "&Users"
      Height          =   588
      Left            =   108
      Picture         =   "Main.frx":0384
      Style           =   1  'Graphical
      TabIndex        =   0
      Top             =   2340
      Width           =   912
   End
   Begin VB.Label lblCaption 
      AutoSize        =   -1  'True
      Caption         =   "Computer Name:"
      Height          =   192
      Index           =   5
      Left            =   108
      TabIndex        =   15
      Top             =   1188
      Width           =   1212
   End
   Begin VB.Label lblCaption 
      AutoSize        =   -1  'True
      Caption         =   "Description:"
      Height          =   192
      Index           =   4
      Left            =   108
      TabIndex        =   13
      Top             =   1764
      Width           =   852
   End
   Begin ComctlLib.ImageList ImageList1 
      Left            =   2952
      Top             =   2376
      _ExtentX        =   804
      _ExtentY        =   804
      BackColor       =   -2147483643
      ImageWidth      =   26
      ImageHeight     =   20
      MaskColor       =   12632256
      _Version        =   327682
      BeginProperty Images {0713E8C2-850A-101B-AFC0-4210102A8DA7} 
         NumListImages   =   3
         BeginProperty ListImage1 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "Main.frx":0546
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "Main.frx":0718
            Key             =   ""
         EndProperty
         BeginProperty ListImage3 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "Main.frx":08EA
            Key             =   ""
         EndProperty
      EndProperty
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_objGeneral                   As clsGeneral
Private m_strComputerName              As String

Private Const constLocal_Computer      As String = "**LOCAL**"

Private Sub cboComputerName_Click()
   m_strComputerName = Me.cboComputerName.Text
   FillGeneral
End Sub

Private Sub cmdClose_Click()
   Unload Me
End Sub

Private Sub cmdInUse_Click()
   frmResources.Show vbModeless
End Sub

Private Sub cmdShares_Click()
   frmSharedResources.Show vbModeless
End Sub

Private Sub cmdUsers_Click()
   frmUserSessions.Show vbModeless
End Sub

Private Function GetComputerNames()
   Dim p_vntComputerNames              As Variant
   Dim p_lngLoop                       As Long
   Dim p_lngNumItems                   As Long

   Me.MousePointer = vbHourglass
   
   p_vntComputerNames = m_objGeneral.GetComputersNames()
   On Error Resume Next
   p_lngNumItems = UBound(p_vntComputerNames)
   On Error GoTo 0
   
   ' ------------------------------------------
   ' Add all the network NT computers
   ' ------------------------------------------
   If p_lngNumItems > 0 Then
      Me.cboComputerName.Clear
      
      For p_lngLoop = 1 To p_lngNumItems
         Me.cboComputerName.AddItem p_vntComputerNames(p_lngLoop)
      Next p_lngLoop
   End If
   
   ' ------------------------------------------
   ' Now find **LOCAL** and make it the selected
   '     item
   ' ------------------------------------------
   p_lngNumItems = Me.cboComputerName.ListCount
   If p_lngNumItems = 1 Then
      Me.cboComputerName.ListIndex = 0
   Else
      For p_lngLoop = 0 To p_lngNumItems - 1
         If Me.cboComputerName.List(p_lngLoop) = constLocal_Computer Then
            Me.cboComputerName.ListIndex = p_lngLoop
            Exit For
         End If
      Next p_lngLoop
   End If
   
   Me.MousePointer = vbNormal

End Function

Public Sub FillGeneral()
   
   If Not m_objGeneral Is Nothing Then
      Set m_objGeneral = Nothing
   End If
   
   Set m_objGeneral = New clsGeneral
   m_objGeneral.Init ServerName:=RemoteServer()
   
   Me.lblSessions.Caption = CStr(m_objGeneral.NumSessions)
   Me.lblFileLocks.Caption = CStr(m_objGeneral.NumFileLocks)
   Me.lblOpenFiles.Caption = CStr(m_objGeneral.NumOpenFiles)
   Me.lblOpenNamedPipes.Caption = CStr(m_objGeneral.NumOpenPipes)
   
   Me.txtComputerDesc = m_objGeneral.ComputerDesc
   
End Sub

Private Sub Form_GotFocus()
   FillGeneral
End Sub

Private Sub Form_Load()
   
   Me.cboComputerName.AddItem constLocal_Computer
   m_strComputerName = constLocal_Computer

   FillGeneral
   Me.Show vbModeless
   Me.Refresh
   
   GetComputerNames
   
End Sub

Public Sub txtComputerDesc_LostFocus()
   m_objGeneral.ComputerDesc = Me.txtComputerDesc.Text
   Me.txtComputerDesc.Text = m_objGeneral.ComputerDesc
End Sub

Public Property Get RemoteServer() As String
   Dim p_strComputerName               As String
   
   p_strComputerName = m_strComputerName
   If p_strComputerName = constLocal_Computer Then
      p_strComputerName = ""
   End If
   
   RemoteServer = p_strComputerName

End Property
