VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "Comctl32.ocx"
Begin VB.Form frmResources 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Open Resources"
   ClientHeight    =   3300
   ClientLeft      =   1452
   ClientTop       =   2088
   ClientWidth     =   6600
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3300
   ScaleWidth      =   6600
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton cmdCloseAllResources 
      Caption         =   "Close &All Resources"
      Enabled         =   0   'False
      Height          =   444
      Left            =   3456
      TabIndex        =   8
      Top             =   2700
      Width           =   1020
   End
   Begin VB.CommandButton cmdCloseResource 
      Caption         =   "&Close Resource"
      Enabled         =   0   'False
      Height          =   444
      Left            =   2376
      TabIndex        =   7
      Top             =   2700
      Width           =   1020
   End
   Begin VB.CommandButton cmdRefresh 
      Caption         =   "&Refresh"
      Height          =   444
      Left            =   1260
      TabIndex        =   6
      Top             =   2700
      Width           =   1020
   End
   Begin VB.CommandButton cmdClose 
      Cancel          =   -1  'True
      Caption         =   "Close"
      Height          =   444
      Left            =   144
      TabIndex        =   5
      Top             =   2700
      Width           =   1020
   End
   Begin ComctlLib.ListView lstvwResources 
      Height          =   2064
      Left            =   108
      TabIndex        =   0
      Top             =   504
      Width           =   6348
      _ExtentX        =   11197
      _ExtentY        =   3641
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   0   'False
      HideSelection   =   0   'False
      _Version        =   327682
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   4
      BeginProperty ColumnHeader(1) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Opened By"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(2) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         SubItemIndex    =   1
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "For"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(3) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         SubItemIndex    =   2
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Locks"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(4) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         SubItemIndex    =   3
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Path"
         Object.Width           =   2540
      EndProperty
   End
   Begin ComctlLib.ImageList ImageList1 
      Left            =   5976
      Top             =   2664
      _ExtentX        =   804
      _ExtentY        =   804
      BackColor       =   -2147483643
      MaskColor       =   12632256
      _Version        =   327682
   End
   Begin VB.Label lblFileLocks 
      Caption         =   "0"
      Height          =   264
      Left            =   3528
      TabIndex        =   4
      Top             =   144
      Width           =   912
   End
   Begin VB.Label lblOpenResources 
      Caption         =   "0"
      Height          =   264
      Left            =   1476
      TabIndex        =   3
      Top             =   144
      Width           =   912
   End
   Begin VB.Label lblCaption 
      AutoSize        =   -1  'True
      Caption         =   "File Locks:"
      Height          =   192
      Index           =   5
      Left            =   2664
      TabIndex        =   2
      Top             =   144
      Width           =   768
   End
   Begin VB.Label lblCaption 
      AutoSize        =   -1  'True
      Caption         =   "Open Resources:"
      Height          =   192
      Index           =   4
      Left            =   144
      TabIndex        =   1
      Top             =   144
      Width           =   1260
   End
End
Attribute VB_Name = "frmResources"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_colFileEnum                  As colFileEnum

Private Sub cmdClose_Click()
   frmMain.FillGeneral
   Unload Me
End Sub

Private Sub cmdCloseAllResources_Click()
   Dim p_lngRtn                        As Long
   Dim p_lngLoop                       As Long
   Dim p_lngFilePtr                    As Long
   Dim p_lngNumItems                   As Long
   Dim p_strFileName                   As String
   
   p_lngNumItems = Me.lstvwResources.ListItems.Count
   
   If p_lngNumItems > 0 Then
      For p_lngLoop = 1 To p_lngNumItems
         
         ' The ID is in the Tag property
         p_lngFilePtr = CLng(Trim$(Me.lstvwResources.ListItems(p_lngLoop).Tag))
         p_strFileName = Me.lstvwResources.ListItems(p_lngLoop).SubItems(3)
         
         m_colFileEnum.CloseFile FilePtr:=p_lngFilePtr, _
                                 CloseOnServer:=frmMain.RemoteServer(), _
                                 CloseFileName:=p_strFileName
      Next p_lngLoop
   End If
   
   RefreshResources
End Sub

Private Sub cmdCloseResource_Click()
   Dim p_lngRtn                        As Long
   Dim p_lngLoop                       As Long
   Dim p_lngFilePtr                    As Long
   Dim p_lngNumItems                   As Long
   Dim p_strFileName                   As String
   
   p_lngNumItems = Me.lstvwResources.ListItems.Count
   
   If p_lngNumItems > 0 Then
      For p_lngLoop = 1 To p_lngNumItems
         If Me.lstvwResources.ListItems(p_lngLoop).Selected = True Then
            ' The ID is in the Tag property
            p_lngFilePtr = CLng(Trim$(Me.lstvwResources.ListItems(p_lngLoop).Tag))
            p_strFileName = Me.lstvwResources.ListItems(p_lngLoop).SubItems(3)
            
            m_colFileEnum.CloseFile FilePtr:=p_lngFilePtr, _
                                    CloseOnServer:=frmMain.RemoteServer(), _
                                    CloseFileName:=p_strFileName
         End If
      Next p_lngLoop
   End If
   
   RefreshResources
End Sub

Private Sub cmdRefresh_Click()
   RefreshResources
End Sub

Private Sub Form_Load()
   Set m_colFileEnum = New colFileEnum
   RefreshResources
End Sub

Private Sub Form_Unload(Cancel As Integer)
   Set m_colFileEnum = Nothing
End Sub

Private Sub RefreshResources()
   Dim p_objFileEnum                   As clsFileEnum
   Dim p_objColHeader                  As ColumnHeader
   Dim p_objNewListItem                As ListItem
   Dim p_lngPermissions                As Long
   Dim p_strPermissions                As String
   Dim p_lngLockCount                  As Long
   Dim p_lngResourceCount              As Long
   
   ' ------------------------------------------
   ' Setup a new collection
   ' ------------------------------------------
   Set m_colFileEnum = Nothing
   Set m_colFileEnum = New colFileEnum
   m_colFileEnum.Init frmMain.RemoteServer()
   
   ' ------------------------------------------
   ' Setup the listview headers
   ' ------------------------------------------
   Me.lstvwResources.ColumnHeaders.Clear
   Me.lstvwResources.ListItems.Clear
   
   Set p_objColHeader = Me.lstvwResources.ColumnHeaders.Add(Text:="Opened By", _
                                                            Width:=Me.lstvwResources.Width * 0.35)
   Set p_objColHeader = Me.lstvwResources.ColumnHeaders.Add(Text:="For", _
                                                            Width:=Me.lstvwResources.Width * 0.15)
   Set p_objColHeader = Me.lstvwResources.ColumnHeaders.Add(Text:="Locks", _
                                                            Width:=Me.lstvwResources.Width * 0.1)
   Set p_objColHeader = Me.lstvwResources.ColumnHeaders.Add(Text:="Path", _
                                                            Width:=Me.lstvwResources.Width * 0.5)
   
   p_lngResourceCount = 0
   p_lngLockCount = 0
   For Each p_objFileEnum In m_colFileEnum
      p_lngResourceCount = p_lngResourceCount + 1
      
      ' ---------------------------------------
      ' See KB article Q176738
      ' ---------------------------------------
      p_lngPermissions = p_objFileEnum.Permissions
      If p_lngPermissions Or PERM_FILE_WRITE Then
         p_strPermissions = "Write"
      ElseIf p_lngPermissions Or PERM_FILE_EXECUTE Then
         p_strPermissions = "Execute"
      ElseIf p_lngPermissions Or PERM_FILE_CREATE Then
         p_strPermissions = "Create"
      ElseIf p_lngPermissions Or PERM_FILE_READ Then
         p_strPermissions = "Read"
      Else
         p_strPermissions = "Unknown"
      End If
      
      Set p_objNewListItem = Me.lstvwResources.ListItems.Add(Text:=p_objFileEnum.UserName)
      p_objNewListItem.SubItems(1) = p_strPermissions
      p_objNewListItem.SubItems(2) = p_objFileEnum.NumberLocks
      p_objNewListItem.SubItems(3) = p_objFileEnum.Pathname
      
      p_objNewListItem.Tag = CStr(p_objFileEnum.ID)
      
      p_lngLockCount = p_lngLockCount + p_objFileEnum.NumberLocks
   Next p_objFileEnum
   
   Me.lblFileLocks.Caption = CStr(p_lngLockCount)
   Me.lblOpenResources.Caption = CStr(p_lngResourceCount)
   
   If p_lngResourceCount > 0 Then
      Me.cmdCloseAllResources.Enabled = True
      Me.cmdCloseResource.Enabled = True
   Else
      Me.cmdCloseAllResources.Enabled = False
      Me.cmdCloseResource.Enabled = False
   End If
End Sub
