VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "Comctl32.ocx"
Begin VB.Form frmSharedResources 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Shared Resources"
   ClientHeight    =   5676
   ClientLeft      =   744
   ClientTop       =   4560
   ClientWidth     =   5604
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5676
   ScaleWidth      =   5604
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton cmdDisconnectAll 
      Caption         =   "Disconnect &All"
      Enabled         =   0   'False
      Height          =   408
      Left            =   4140
      TabIndex        =   6
      Top             =   5148
      Width           =   1236
   End
   Begin VB.CommandButton cmdDisconnect 
      Caption         =   "&Disconnect"
      Enabled         =   0   'False
      Height          =   408
      Left            =   2808
      TabIndex        =   5
      Top             =   5148
      Width           =   1236
   End
   Begin VB.CommandButton cmdClose 
      Cancel          =   -1  'True
      Caption         =   "Close"
      Height          =   408
      Left            =   180
      TabIndex        =   4
      Top             =   5148
      Width           =   1236
   End
   Begin ComctlLib.ListView lstvwConnectedUsers 
      Height          =   2136
      Left            =   108
      TabIndex        =   1
      Top             =   2628
      Width           =   5376
      _ExtentX        =   9483
      _ExtentY        =   3768
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   0   'False
      HideSelection   =   0   'False
      _Version        =   327682
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   2
      BeginProperty ColumnHeader(1) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Connected Users"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(2) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         SubItemIndex    =   1
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Time"
         Object.Width           =   2540
      EndProperty
   End
   Begin ComctlLib.ListView lstvwShares 
      Height          =   2028
      Left            =   108
      TabIndex        =   0
      Top             =   324
      Width           =   5376
      _ExtentX        =   9483
      _ExtentY        =   3577
      View            =   3
      LabelEdit       =   1
      Sorted          =   -1  'True
      LabelWrap       =   0   'False
      HideSelection   =   0   'False
      _Version        =   327682
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   3
      BeginProperty ColumnHeader(1) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Sharename"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(2) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         SubItemIndex    =   1
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Uses"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(3) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         SubItemIndex    =   2
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Path"
         Object.Width           =   2540
      EndProperty
   End
   Begin VB.Label lblCaption 
      AutoSize        =   -1  'True
      Caption         =   "Users Connected to Share:"
      Height          =   192
      Index           =   2
      Left            =   144
      TabIndex        =   8
      Top             =   2412
      Width           =   1920
   End
   Begin VB.Label lblCaption 
      AutoSize        =   -1  'True
      Caption         =   "Available Shares:"
      Height          =   192
      Index           =   1
      Left            =   144
      TabIndex        =   7
      Top             =   108
      Width           =   1272
   End
   Begin VB.Label lblConnectedUsers 
      Height          =   192
      Left            =   1620
      TabIndex        =   3
      Top             =   4860
      Width           =   660
   End
   Begin VB.Label lblCaption 
      AutoSize        =   -1  'True
      Caption         =   "Connected Users:"
      Height          =   192
      Index           =   0
      Left            =   180
      TabIndex        =   2
      Top             =   4860
      Width           =   1284
   End
End
Attribute VB_Name = "frmSharedResources"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_colShareEnum                 As colShareEnum
Private m_colConnectEnum               As colConnectionEnum
Private m_colUserSessions              As colSessionEnum

Private Sub cmdClose_Click()
   frmMain.FillGeneral
   Unload Me
End Sub

Private Sub cmdDisconnect_Click()
   Dim p_lngLoop                       As Long
   Dim p_strUserName                   As String
   Dim p_strUncClientName              As String
   
   If Not m_colUserSessions Is Nothing Then
      Set m_colUserSessions = Nothing
   End If
   Set m_colUserSessions = New colSessionEnum
   m_colUserSessions.Init ServerName:=frmMain.RemoteServer()
   
   If Me.lstvwConnectedUsers.ListItems.Count > 0 Then
      For p_lngLoop = 1 To Me.lstvwConnectedUsers.ListItems.Count
         If Me.lstvwConnectedUsers.ListItems(p_lngLoop).Selected = True Then
            p_strUserName = Trim$(Me.lstvwConnectedUsers.ListItems(p_lngLoop).Text)
            p_strUncClientName = Trim$(Me.lstvwConnectedUsers.ListItems(p_lngLoop).Tag)
            
            If Len(Trim$(p_strUserName)) > 0 Then
               m_colUserSessions.DeleteItem UncClientName:=p_strUncClientName, _
                                            UserName:=p_strUserName
            End If
         End If
      Next p_lngLoop
   End If
   
   RefreshResources
   
End Sub

Private Sub cmdDisconnectAll_Click()
   Dim p_lngLoop                       As Long
   Dim p_strUserName                   As String
   Dim p_strUncClientName              As String
   
   If Not m_colUserSessions Is Nothing Then
      Set m_colUserSessions = Nothing
   End If
   Set m_colUserSessions = New colSessionEnum
   m_colUserSessions.Init ServerName:=frmMain.RemoteServer()
   
   If Me.lstvwConnectedUsers.ListItems.Count > 0 Then
      For p_lngLoop = 1 To Me.lstvwConnectedUsers.ListItems.Count
         p_strUserName = Trim$(Me.lstvwConnectedUsers.ListItems(p_lngLoop).Text)
         p_strUncClientName = Trim$(Me.lstvwConnectedUsers.ListItems(p_lngLoop).Tag)
      
         If Len(Trim$(p_strUserName)) > 0 Then
            m_colUserSessions.DeleteItem UncClientName:=p_strUncClientName, _
                                         UserName:=p_strUserName
         End If
      Next p_lngLoop
   End If
   
   RefreshResources
   
End Sub

Private Sub Form_Load()
   
   RefreshResources
   
   If Me.lstvwShares.ListItems.Count > 0 Then
      Me.lstvwShares.ListItems.Item(1).EnsureVisible
      Me.lstvwShares.ListItems.Item(1).Selected = True
   End If
   
End Sub

Private Sub RefreshResources()
   Dim p_objShareEnum                  As clsShareEnum
   Dim p_objColHeader                  As ColumnHeader
   Dim p_objNewListItem                As ListItem
   
   ' ------------------------------------------
   ' Setup a new collection
   ' ------------------------------------------
   Set m_colShareEnum = Nothing
   Set m_colShareEnum = New colShareEnum
   m_colShareEnum.Init ServerName:=frmMain.RemoteServer()
   
   ' ------------------------------------------
   ' Setup the listview headers
   ' ------------------------------------------
   Me.lstvwShares.ColumnHeaders.Clear
   Me.lstvwShares.ListItems.Clear
   Set p_objColHeader = Me.lstvwShares.ColumnHeaders.Add(Text:="Sharename", _
                                                         Width:=Me.lstvwShares.Width * 0.35)
   Set p_objColHeader = Me.lstvwShares.ColumnHeaders.Add(Text:="Uses", _
                                                         Width:=Me.lstvwShares.Width * 0.15)
   Set p_objColHeader = Me.lstvwShares.ColumnHeaders.Add(Text:="Path", _
                                                         Width:=Me.lstvwShares.Width * 0.5)
   Me.lstvwConnectedUsers.ColumnHeaders.Clear
   Me.lstvwConnectedUsers.ListItems.Clear
   Set p_objColHeader = Me.lstvwConnectedUsers.ColumnHeaders.Add(Text:="Connected Users", _
                                                                 Width:=Me.lstvwConnectedUsers.Width * 0.5)
   Set p_objColHeader = Me.lstvwConnectedUsers.ColumnHeaders.Add(Text:="Time", _
                                                                 Width:=Me.lstvwConnectedUsers.Width * 0.16)
   Set p_objColHeader = Me.lstvwConnectedUsers.ColumnHeaders.Add(Text:="In Use", _
                                                                 Width:=Me.lstvwConnectedUsers.Width * 0.16)
   
   For Each p_objShareEnum In m_colShareEnum
      Set p_objNewListItem = Me.lstvwShares.ListItems.Add(Text:=p_objShareEnum.ShareName)
      p_objNewListItem.SubItems(1) = p_objShareEnum.NumCurrConnections
      p_objNewListItem.SubItems(2) = p_objShareEnum.Path
   Next p_objShareEnum
   
   If Me.lstvwConnectedUsers.ListItems.Count > 0 Then
      Me.cmdDisconnect.Enabled = True
      Me.cmdDisconnectAll.Enabled = True
   Else
      Me.cmdDisconnect.Enabled = False
      Me.cmdDisconnectAll.Enabled = False
   End If
   
   Me.lblConnectedUsers.Caption = CStr(0)

End Sub

Private Sub lstvwShares_ItemClick(ByVal Item As ComctlLib.ListItem)
   Dim p_strQualifier                  As String
   Dim p_strConnectType                As String
   Dim p_lngNumConnects                As Long
   Dim p_objConnectEnum                As clsConnectionEnum
   Dim p_objColHeader                  As ColumnHeader
   Dim p_objNewListItem                As ListItem
   Dim p_enumConnectType               As enumShareType
   
   p_strQualifier = Trim$(Item.Text)
   
   ' ------------------------------------------
   ' Setup a new collection
   ' ------------------------------------------
   Set m_colConnectEnum = Nothing
   Set m_colConnectEnum = New colConnectionEnum
   m_colConnectEnum.Init Qualifier:=p_strQualifier, _
                         ServerName:=frmMain.RemoteServer()
   
   ' ------------------------------------------
   ' Setup the listview headers
   ' ------------------------------------------
   Me.lstvwConnectedUsers.ColumnHeaders.Clear
   Me.lstvwConnectedUsers.ListItems.Clear
   Set p_objColHeader = Me.lstvwConnectedUsers.ColumnHeaders.Add(Text:="Connected Users", _
                                                                 Width:=Me.lstvwConnectedUsers.Width * 0.5)
   Set p_objColHeader = Me.lstvwConnectedUsers.ColumnHeaders.Add(Text:="Time", _
                                                                 Width:=Me.lstvwConnectedUsers.Width * 0.16)
   Set p_objColHeader = Me.lstvwConnectedUsers.ColumnHeaders.Add(Text:="In Use", _
                                                                 Width:=Me.lstvwConnectedUsers.Width * 0.16)
   p_lngNumConnects = 0
   For Each p_objConnectEnum In m_colConnectEnum
      p_lngNumConnects = p_lngNumConnects + 1
      Set p_objNewListItem = Me.lstvwConnectedUsers.ListItems.Add(Text:=p_objConnectEnum.UserName)
      
      p_enumConnectType = p_objConnectEnum.ConnectionType
      Select Case p_enumConnectType
         Case STYPE_DISKTREE
            p_strConnectType = "Yes"
         Case Else
            p_strConnectType = "No"
      End Select
      
      p_objNewListItem.SubItems(1) = p_objConnectEnum.ConnectTimeFormatted
      p_objNewListItem.SubItems(2) = p_strConnectType
      p_objNewListItem.Tag = p_objConnectEnum.NetName
   Next p_objConnectEnum
   
   Me.lblConnectedUsers.Caption = p_lngNumConnects
   
   If Me.lstvwConnectedUsers.ListItems.Count > 0 Then
      Me.cmdDisconnect.Enabled = True
      Me.cmdDisconnectAll.Enabled = True
   Else
      Me.cmdDisconnect.Enabled = False
      Me.cmdDisconnectAll.Enabled = False
   End If
   
End Sub
